<div class="flex flex-col h-screen">
  <mat-card class="m-4">
    <mat-card-header>
      <mat-card-title>Authorization Server Settings</mat-card-title>
    </mat-card-header>
    <mat-card-content class="flex flex-col">
      <form [formGroup]="authSettingsForm">

        <mat-tab-group>
          <!-- Server and Organization Settings -->
          <mat-tab label="Server and Organization Settings">
            <mat-card class="m-4">
              <mat-card-content>
                <mat-form-field class="w-full">
                  <mat-label>Server Url</mat-label>
                  <input matInput formControlName="issuerUrl" readonly />
                  <mat-checkbox formControlName="disableSignup" matSuffix>Disable Sign Up</mat-checkbox>
                </mat-form-field>
                <mat-form-field class="w-full" (click)="toggleOrgName()">
                  <mat-label>Organization Name</mat-label>
                  <input matInput formControlName="organizationName" />
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Allowed Scopes</mat-label>
                  <mat-select formControlName="scopes" multiple required>
                    <mat-option *ngFor="let scope of scopes" [value]="scope">{{scope}}</mat-option>
                  </mat-select>
                </mat-form-field>
              </mat-card-content>
            </mat-card>
          </mat-tab>
          <!-- Client and Storage Settings -->
          <mat-tab label="Client and Storage Settings">
            <mat-card class="m-4">
              <mat-card-content>
                <mat-form-field class="w-full">
                  <mat-label>Infrastructure Console Client ID</mat-label>
                  <mat-select formControlName="infrastructureConsoleClientId">
                    <mat-option *ngFor="let client of clientList" [value]="client.clientId">
                      {{ client.name + ' (' + client.clientId + ')' }}
                    </mat-option>
                  </mat-select>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Avatar Bucket UUID</mat-label>
                  <mat-select formControlName="avatarBucket">
                    <mat-option *ngFor="let storage of storageList" [value]="storage.uuid">
                      {{ storage.name + ' (' + storage.uuid + ')' }}
                    </mat-option>
                  </mat-select>
                </mat-form-field>
              </mat-card-content>
            </mat-card>
          </mat-tab>
          <!-- Email and Token Settings -->
          <mat-tab label="Email and Token Settings">
            <mat-card class="m-4">
              <mat-card-content>
                <mat-form-field class="w-full">
                  <mat-label>System Email Account UUID</mat-label>
                  <mat-select formControlName="systemEmailAccount">
                    <mat-option *ngFor="let email of emailAccounts" [value]="email.uuid">
                      {{ email.name + ' (' + email.uuid + ')' }}
                    </mat-option>
                  </mat-select>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Refresh Token Expires in Hours</mat-label>
                  <input matInput formControlName="refreshTokenExpiresInHours" type="number" />
                  <mat-checkbox formControlName="enableChoosingAccount" matSuffix>Enable Account Choice</mat-checkbox>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Disallow Login after number of failed attempts (No limit:
                    0)</mat-label>
                  <input matInput formControlName="allowedFailedLoginAttempts" type="number" />
                  <mat-checkbox formControlName="enableCustomLogin" matSuffix>Enable Custom Login Pages</mat-checkbox>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Authorization Code Expires in Minutes</mat-label>
                  <input matInput formControlName="authCodeExpiresInMinutes" type="number" />
                  <mat-checkbox formControlName="enableUserPhone" matSuffix>Enable User Phone</mat-checkbox>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>OTP expiry in minutes</mat-label>
                  <input matInput formControlName="otpExpiry" type="number" />
                  <mat-checkbox formControlName="regenerateOTP" matSuffix>Regenerate OTP</mat-checkbox>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Email Delay in Seconds</mat-label>
                  <input matInput min="60" type="number" formControlName="emailDelayInSeconds" />
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Password Reset Interval (Days)</mat-label>
                  <input matInput min="0" type="number" formControlName="passwordResetIntervalDays" />
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>OTP Resend Delay (seconds)</mat-label>
                  <input matInput min="0" type="number" formControlName="resendOTPDelayInSec" />
                </mat-form-field>
              </mat-card-content>
            </mat-card>
          </mat-tab>
          <!-- User and Appearance Settings -->
          <mat-tab label="User and Appearance Settings">
            <mat-card class="m-4">
              <mat-card-content>
                <mat-form-field class="w-full">
                  <mat-label>Do not allow user to be deleted</mat-label>
                  <input matInput readonly />
                  <mat-checkbox formControlName="isUserDeleteDisabled" matSuffix>Disable User Deletion</mat-checkbox>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Logo Url</mat-label>
                  <input matInput formControlName="logoURL" />
                  <mat-checkbox formControlName="passwordChangeRestricted" matSuffix>Password Change Restricted</mat-checkbox>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Favicon Url</mat-label>
                  <input matInput formControlName="faviconURL" />
                  <mat-checkbox formControlName="enableUserOTP" matSuffix>Enable User OTP</mat-checkbox>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Help Url</mat-label>
                  <input matInput formControlName="helpURL" />
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Privacy Url</mat-label>
                  <input matInput formControlName="privacyURL" />
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Terms Url</mat-label>
                  <input matInput formControlName="termsURL" />
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Copyright Message</mat-label>
                  <textarea matInput formControlName="copyrightMessage"></textarea>
                </mat-form-field>
              </mat-card-content>
            </mat-card>
          </mat-tab>
          <!-- Email Messages and Subjects Settings -->
          <mat-tab label="Email Messages and Subjects Settings">
            <mat-card class="m-4">
              <mat-card-content>
                <mat-form-field class="w-full">
                  <mat-label>Forgot Password Message</mat-label>
                  <textarea matInput formControlName="forgotPasswordMessage"></textarea>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Forgot Password Subject</mat-label>
                  <input matInput formControlName="forgotPasswordSubject" />
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Complete Signup Message</mat-label>
                  <textarea matInput formControlName="completeSignupMessage"></textarea>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Complete Signup Subject</mat-label>
                  <input matInput formControlName="completeSignupSubject" />
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Verify Existing Email Message</mat-label>
                  <textarea matInput formControlName="verifyExistingEmailMessage"></textarea>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Verify Existing Email Subject</mat-label>
                  <input matInput formControlName="verifyExistingEmailSubject" />
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Verify New Email Message</mat-label>
                  <textarea matInput formControlName="verifyNewEmailMessage"></textarea>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Verify New Email Subject</mat-label>
                  <input matInput formControlName="verifyNewEmailSubject" />
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Login Otp Message</mat-label>
                  <textarea matInput formControlName="loginOtpMessage"></textarea>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Login Otp Subject</mat-label>
                  <input matInput formControlName="loginOtpSubject" />
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Password Expiry Message</mat-label>
                  <textarea matInput formControlName="passwordExpiryMessage"></textarea>
                </mat-form-field>
                <mat-form-field class="w-full">
                  <mat-label>Password Expiry Subject</mat-label>
                  <input matInput formControlName="passwordExpirySubject" />
                </mat-form-field>
              </mat-card-content>
            </mat-card>
          </mat-tab>
        </mat-tab-group>
      </form>
    </mat-card-content>
    <mat-card-actions>
      <button (click)="updateAuthSettings()" mat-button color="primary" [disabled]="!authSettingsForm.valid">
        Update
      </button>
    </mat-card-actions>
  </mat-card>
  <!-- Security Settings Card -->
  <mat-card class="m-4">
    <mat-card-header>
      <mat-card-title>Security Settings</mat-card-title>
    </mat-card-header>
    <mat-card-content class="flex flex-col justify-start">
      <p>
        Deleting bearer tokens will revoke access for all connected apps and
        users
      </p>
      <button (click)="deleteBearerTokens()" [disabled]="disableDeleteTokens" mat-raised-button color="warn">
        Delete Bearer Tokens
      </button>
      <p>Deleting user sessions will logout all logged in users</p>
      <button (click)="deleteUserSessions()" [disabled]="disableDeleteSessions" mat-raised-button color="warn">
        Delete User Sessions
      </button>
    </mat-card-content>
  </mat-card>
</div>